function [x, nit, resvec] = gs(afun, b, tol, maxit)
%
% Algorithme du gradient linaire
%
%    Copyright (C) 2012-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
x = zeros(size(b));
resvec = zeros(maxit, 1);

nit = 0;

r = b;
relres = norm(r) / norm(b);

while relres > tol & nit < maxit
%     aux = afun(r);
    alpha = (r' * r) / (r' * afun(r)) / 1.05;
    x = x + alpha * r;
    pred = afun(x);
    r = b - pred;
    relres = norm(r) / norm(b);
    nit = nit + 1;
    resvec(nit) = relres;
end

resvec = resvec(1:nit);

end
